class KmpMethod{
  String _sourceText = "";
  String _searchText = "";
  int _sourceTextLength = 0;
  int _searchTextLength = 0;

  KmpMethod(String source, String search){
    _sourceText = source;
    _searchText = search;
    
    _sourceTextLength = _sourceText.length;
    _searchTextLength = _searchText.length;
  }

  //_searchTextLengthのゲッター
  int GetSearchTextLength(){
    return _searchTextLength;
  }

  //_sourceTextLengthのゲッター
  int GetSourceTextLength(){
    return _sourceTextLength;
  }

  //_searchTextのゲッター
  String GetSearchText(){
    return _searchText;
  }

  //_searchTextのセッター
  void SetSearchText(String search){
    _searchText = search;
    _searchTextLength = _searchText.length;
  }

  //_sourceTextのゲッター
  String GetSourceText(){
    return _sourceText;
  }

  List<int> _Search(){
    var i = 0;
    var matched = 0;
    var matched_point = <int>[];

    while(i<_sourceTextLength){
      var j = 0;
      while(j<_searchTextLength){

        //文字列の比較
        if(_sourceText[i] == _searchText[j]){
          matched++;
          j++;

          if(matched == _searchTextLength){
            matched_point.add(i-(_searchTextLength-1));
            i = i+_searchTextLength;
            matched = 0;
            break;
          }else{
            i++;
          }
        }else{
          if(matched == 0){
            i++;
          }else{
            i = i+matched;
          }
          matched = 0;
          break;
        }
      }
    }

    return matched_point;
  }

  List<int> GetMatchedPoint(){
    return _Search();
  }
}